//#define DEBUG_MODE_FULL
#include "script_component.hpp"

LOG(MSG_INIT);

ADDON = false;

// load userconfig
call compile preprocessFile "\userconfig\asr\config_airearming.hpp";

if (isNil QUOTE(GVAR(run))) then {GVAR(run) = 1};
if (isNil QUOTE(GVAR(civ))) then {GVAR(civ) = 0};
if (isNil QUOTE(GVAR(sidearm))) then {GVAR(sidearm) = 1};

GVAR(menu) = [
	["EQUIPMENT AI", False],
	["Enable Rearming", [2], "", -5, [ ["expression", "[1] call asr_vfai_fnc_runSwitch"] ], "0", "0"],
	["Disable Rearming", [3], "", -5, [ ["expression", "[0] call asr_vfai_fnc_runSwitch"] ], "0", "0"] 
];

FUNC(found) = { // case insensitive find
	PARAMS_2(_needle,_haystack);
	private "_in";
	_in = (({_needle == _x} count _haystack) > 0);
	TRACE_3("FOUND",_needle,_haystack,_in);
	_in
};

FUNC(test) = {
	PARAMS_1(_unit);
	private["_ret","_side"];
	_side = getNumber(configFile >> "CfgVehicles" >> (typeOf _unit) >> "side");
	_ret = (GVAR(run) == 1 && (GVAR(civ) == 1 || _side != 3) && (local _unit) && (lifeState _unit) == "ALIVE" && !(isPlayer _unit));
	_ret
};

FUNC(inv) = {
	PARAMS_1(_unit);
	private "_return";
	_return = [];
	{	_return set [count _return, (configfile >> "cfgWeapons" >> _x)]	} forEach (weapons _unit);
	{	_return set [count _return, (configfile >> "cfgMagazines" >> _x)]	} forEach (magazines _unit);
	_return
};

FUNC(menuToggle) = {
	if (GVAR(run) == 1) then {
		GVAR(menu) set [1,["Enable Rearming", [2], "", -5, [ ["expression", "[1] call asr_vfai_fnc_runSwitch"] ], "0", "0"]];
		GVAR(menu) set [2,["Disable Rearming", [3], "", -5, [ ["expression", "[0] call asr_vfai_fnc_runSwitch"] ], "1", "1"]];
		hintSilent "AI Rearming Enabled";
	} else {
		GVAR(menu) set [1,["Enable Rearming", [2], "", -5, [ ["expression", "[1] call asr_vfai_fnc_runSwitch"] ], "1", "1"]];
		GVAR(menu) set [2,["Disable Rearming", [3], "", -5, [ ["expression", "[0] call asr_vfai_fnc_runSwitch"] ], "0", "0"]];
		hintSilent "AI Rearming Disabled";
	};
};

FUNC(runSwitch) = {
	if (count _this > 0) then {
		GVAR(run) = _this select 0;
	} else {
		GVAR(run) = if (GVAR(run) == 1) then {0} else {1};
	};
	call FUNC(menuToggle);
};

FUNC(isMedic) = { // same as the ACE function, except we need it on servers too
	private ["_isMedic"];
	PARAMS_1(_unit);
	_isMedic = _unit getVariable "ace_w_ismedic";
	if (isNil "_isMedic") then { _isMedic = getNumber (configFile >> "CfgVehicles" >> typeOf _unit >> "attendant") == 1 };
	_isMedic;
};

PREP(getCompatMags);
PREP(invSlotType);
PREP(invSlotsEmpty);
PREP(getType);
PREP(isUnc);
PREP(isReady);
PREP(foundMag);
PREP(countMags);
PREP(inventoryCheck);
PREP(getCargo);
PREP(getNearMags);
PREP(getNearWeapons);
PREP(timeCheck);
PREP(Equipment_AI);

FUNC(invCodeToArray) = compile preprocessFileLineNumbers "\Ca\Modules\Functions\inventory\fn_invCodeToArray.sqf";

ADDON = true;
