// work based on Equipment AI (ARMA II) build 019 simplified path by Victor Farbau
// Manages Weapon and Ammo inventory
// New version for Arrowhead and ACE2 by Robalo[AS]

//#define DEBUG_MODE_FULL
#include "script_component.hpp"

PARAMS_1(_unit);
private["_ace","_to","_rtf","_acew","_need","_na","_nw","_nc","_nt","_place","_co","_last","_int","_oksec","_what"];

_ace = isClass (configFile >> "CfgPatches" >> "ace_main"); // true if the ACE mod is active
_rtf = compile "[_unit] joinSilent (leader group _unit)";
_last = 0; // will hold last time this unit grabbed some ammo
_int = 10 + random 10;
waituntil {time > _int};

_oksec = getArray (configFile >> "CfgVehicles" >> (typeOf _unit) >> "weapons"); // get unit's weapons from config
_oksec = + (weapons _unit); // add current weapons to cover custom mission loadouts
_oksec = + ["M136","RPG7V","RPG18","SMAW","MAAWS","BAF_NLAW_Launcher","ACE_RPG7V_PGO7","ACE_M72A2","ACE_M72","ACE_RPG22","ACE_RPG27","ACE_M136_CSRS"]; // add launchers that are ok to grab for anybody

while {true} do {
	if ([_unit] call FUNC(test)) then {

  	// ACE Wounds may be enabled/disabled during the mission
  	_acew = _ace && !(isNil "ace_sys_wounds_enabled");
  	//TRACE_3("ACE",_unit,_ace,_acew);
  
  	// So what do I need ?
  	_need = [_unit, _acew, _last] call FUNC(inventoryCheck);
  	//TRACE_2("NEED",_unit,_need);
  
  	_nw = _need select 0; // weapons ?
  	_na = _need select 1; // ammo ?
  	_nt = _need select 2; // [types]
  	_nc = _need select 3; // [counts]
  
  	// Start working, Wall-E
  	if ([_unit,_acew] call FUNC(isReady)) then {
  
    	if (_na) then	{	// LOG("SEARCHING FOR AMMO");
  		
  			_place = [_unit,_nc,_nt,_acew] call FUNC(getNearMags);
  			sleep 3;
  
  			// TAKING AMMO
  			
  			if (count _place > 1) then {
  				_co = _place select 0;
  				_what = _place select 2;
  				_unit doMove (getpos _co);

  				_to = 30; // timeout
  				for "_i" from _to to 0 step -1 do {
  					if (unitready _unit) exitWith {};
  					DEC(_to);	sleep 1;
  				};
  				
  				if (_to > 0 && _co != objNull && _unit distance _co < 10) then {
  					{ // for each item found
  						switch (_what) do {
  							case "CARGO": {
  								if ([_x,(getMagazineCargo _co) select 0] call FUNC(found)) then {
    								//TRACE_3("TAKEMAGAZINE < CARGO",_unit,_co,_x);
    								_unit doWatch _co;
    								_unit action ["TAKEMAGAZINE", _co, _x];
  								};
  							};
  							case "DEADGUY": {
    							if ([_co,_acew] call FUNC(isUnc)) then { // is dead or unconscious
      							if ([_x, (magazines _co)] call FUNC(found)) then { // and still has the item
      								//TRACE_3("TAKEMAGAZINE < DEAD BODY",_unit,_co,_x);
      								_unit doWatch _co;
      								_unit action ["TAKEMAGAZINE", _co, _x];
      							} else { // check backpack
      								if ([_x,(getMagazineCargo unitBackpack _co) select 0] call FUNC(found)) then {
      									//TRACE_3("TAKEMAGAZINE < DEAD PACK",_unit,_co,_x);
      									_unit doWatch _co;
      									_unit action ["TAKEMAGAZINE", unitbackpack _co, _x];
      								};
      							};
            			};
  							};
  							case "BISRUCK": {
            			if ([_x,(getMagazineCargo unitBackpack _co) select 0] call FUNC(found)) then {
      							//TRACE_3("TAKEMAGAZINE < BIS PACK",_unit,_co,_x);
      							_unit doWatch _co;
      							_unit action ["TAKEMAGAZINE", unitbackpack _co, _x];
           				};
  							};
  							case "ACERUCK": {
            			if ([_co] call ace_sys_ruck_fnc_HasRuck && [_x,[_co] call ace_sys_ruck_fnc_RuckMagazines] call FUNC(found)) then {
            				//TRACE_3("TAKEMAGAZINE < ACE PACK",_unit,_co,_x);
            				_unit doWatch _co;
            				_unit addMagazine _x; // ugly
            				[_co,_x] call ace_sys_ruck_fnc_RemoveMagFromRuck;
            			};
  							};
  						};
  						sleep 3;
  					} forEach (_place select 1);
  					_nw = false; // if mags were taken skip weapons to reset the loop
  					_last = time; // mark last time operation completed
  					//TRACE_2("LAST",_unit,_last);
  				} else {
  					//TRACE_1("TIMED OUT TAKING MAG",_unit);
  				};
  				sleep 3; call _rtf; // return to formation
  			}; // foundAmmo
  
    	}; // need ammo
  
      if (_nw) then {	// LOG("SEARCHING FOR WEAPONS");
  
    		_place = [_unit,_nc,_acew,_oksec] call FUNC(getNearWeapons);
    		sleep 3;
  
  			// TAKING WEAPONS
  
    		if (count _place > 1) then {
  				_co = _place select 0;
  				_what = _place select 2;
    			_unit doMove (getpos _co);

  				_to = 30; // timeout
  				for "_i" from _to to 0 step -1 do {
  					if (unitready _unit) exitWith {};
  					DEC(_to);	sleep 1;
  				};

    			if (_to > 0  && _co != objNull && _unit distance _co < 10) then	{
  					{ // for each weapon found
  						switch (_what) do {
  							case "CARGO": {
  								if ([_x,(getWeaponCargo _co) select 0] call FUNC(found)) then {
  									//TRACE_3("TAKEWEAPON < CARGO",_unit,_co,_x);
  									_unit doWatch _co;
  									_unit action ["TAKEWEAPON", _co, _x];
  								};
  							};
  							case "DEADGUY": {
    							if ([_co,_acew] call FUNC(isUnc) && _co hasWeapon _x) then { // dead or unconscious and still has the weapon
  									//TRACE_3("TAKEWEAPON < BODY",_unit,_co,_x);
  									_unit doWatch _co;
  									_unit action ["TAKEWEAPON", _co, _x];
            			};
  							};
  							case "BISRUCK": {//not implemented
  							};
  							case "ACERUCK": {//not implemented
  							};
  						}; 
  						sleep 3;
  					} forEach (_place select 1);
    			} else {
    				//TRACE_1("TIMED OUT TAKING WEAPON",_unit);
    			};
    			sleep 3; call _rtf; // return to formation
      	}; // foundWeapon
    	}; // needWeapon
  	}; // ready
  }; sleep _int;
};
