// unit searches for places with magazines as needed
// returns place and useful stuff found [object,[items]]
//#define DEBUG_MODE_FULL
#include "script_component.hpp"

PARAMS_4(_unit,_nc,_nt,_ace);
private["_place","_found","_search","_goodies","_type"];

_place = [];
_found = [];
_search = nearestObjects [_unit, ["ReammoBox","AllVehicles","Camp_base"], 50];

{	scopename "searching";
	if (surfaceIsWater position _x) then {
		TRACE_2("THAT GEAR IS WET",_unit,_x);
	} else {
  	_goodies = [];
  	//TRACE_2("CHECKING",_unit,_x);
  	if (_x isKindOf "Man") then {
  		if ([_x,_ace] call FUNC(isUnc)) then { // unit is down
  			_gc = getMagazineCargo (unitBackpack _x);
  			_goodies = [_gc] call FUNC(getCargo);
  			_goodies = + (magazines _x);
  			_type = "DEADGUY";
  			//TRACE_3("FOUND ON BODY",_unit,_x,_goodies);
  		} else { // alive and kickin, care to share ?
  			if ((group _x) == (group _unit) && !(isPlayer _x)) then { // another AI buddy
  				if (isClass (configFile >> "CfgPatches" >> "ace_sys_ruck") && [_x] call ace_sys_ruck_fnc_HasRuck) then {
  					_goodies = [_x] call ace_sys_ruck_fnc_RuckMagazines;
  					_type = "ACERUCK";
  				} else {
  					_gc = getMagazineCargo (unitBackpack _x);
  					_goodies = [_gc] call FUNC(getCargo);
  					_type = "BISRUCK";
  				};
  			};
  		};
  	} else { //vehicle, check cargo
  		_gc = getMagazineCargo _x;
  		_goodies = [_gc] call FUNC(getCargo);
  		_type = "CARGO";
  		//TRACE_3("FOUND ON CARGO",_unit,_x,_goodies);
  	};
  	if (count _goodies > 0) then {
  		_found = [_goodies,_nc,_nt] call FUNC(foundMag);
  		if (count _found > 0) then {
  			_place set [0,_x];
  			_place set [1,_found];
  			_place set [2,_type];
  			breakOut "searching";
  		};
  	};
	};
} forEach _search;

_place
