// unit searches for places with weapons as needed
// returns place and useful stuff found [object,[items]]
//#define DEBUG_MODE_FULL
#include "script_component.hpp"

PARAMS_4(_unit,_nc,_acew,_oksec);
private["_place","_found","_search","_w","_gc","_type"];

_place = [];
_found = [];
_search = nearestObjects [_unit, ["ReammoBox","AllVehicles","Camp_base"], 50];

{ scopename "searching";
	if (surfaceIsWater position _x) then {
		TRACE_2("THAT GEAR IS WET",_unit,_x);
	} else {
  	if (_x isKindOf "Man") then {
  		if ([_x,_acew] call FUNC(isUnc)) then {
  			_w = primaryWeapon _x;
  			if ( (_nc select 0) > 0 && ([_w] call FUNC(getType)) in ["RIFLE","SNIPER","MG","AR"] && (_x ammo _w > 0) ) then {
  				_found set [count _found, _w];
  				if ([_w] call FUNC(getType) != "RIFLE") then {_nc set [1,0]};
  			};
  			_w = secondaryWeapon _x;
  			if ( (_nc select 1) > 0 && [_w] call FUNC(getType) == "LAUNCHER" && [_w,_oksec] call FUNC(found) && (_x ammo _w > 0) ) then {
  				_found set [count _found, _w];
  			};
  			if ((_nc select 2) > 0) then {
  				_w = [_x] call CBA_fnc_getPistol;
  				if (_w != "") then {_found set [count _found, _w]};
  			};
  			_type = "DEADGUY";
  		};
  	} else { //vehicle, check cargo
  		_gc = (getWeaponCargo _x) select 0;
  		//TRACE_3("WEAPON CARGO",_unit,_x,_gc);
  		{ // foreach weapon type found in this cargo
  			switch ([_x] call FUNC(getType)) do {
  				case "RIFLE":    { if (_nc select 0 > 0 && _x != _nt select 0) then {_found set [count _found, _x]; _nc set [0,0]} };
  				case "SNIPER":   { if (_nc select 0 > 0 && _x != _nt select 0) then {_found set [count _found, _x]; _nc set [0,0]; _nc set [1,0]} };
  				case "AR":       { if (_nc select 0 > 0 && _x != _nt select 0) then {_found set [count _found, _x]; _nc set [0,0]; _nc set [1,0]} };
  				case "MG":       { if (_nc select 0 > 0 && _x != _nt select 0) then {_found set [count _found, _x]; _nc set [0,0]; _nc set [1,0]} };
  				case "LAUNCHER": { if (_nc select 1 > 0 && _x != _nt select 1 && [_x,_oksec] call FUNC(found)) then {_found set [count _found, _x]; _nc set [1,0]} };
  				case "PISTOL":   { if (_nc select 2 > 0 && _x != _nt select 2) then {_found set [count _found, _x]; _nc set [2,0]} };
  			};
  		} foreach _gc;
  		_type = "CARGO";
  	};
  	if (count _found > 0) then {
  		_place set [0,_x];
  		_place set [1,_found];
  		_place set [2,_type];
  		TRACE_2("WEAPONS FOUND",_unit,_place);
  		breakOut "searching";
  	};
	};
} forEach _search;

_place
