//#define DEBUG_MODE_FULL
#include "script_component.hpp"

PARAMS_3(_unit,_acew,_last);

private["_nt","_nc","_nw","_na","_needmax","_locksecondary","_w","_t","_freeslots","_i","_p","_s","_full"];

_full = [_unit,_last] call FUNC(timeCheck); // full inventory checks at larger intervals
//TRACE_2("FULL CHECK",_unit,_full);

_nt = [
	"", // 0 primary weapon
	"", // 1 secondary
	"", // 2 sidearm
	[], // 3 primary ammo pri slots
	[], // 4 primary ammo sec slots
	[], // 5 secondary ammo pri slots
	[], // 6 secondary ammo sec slots
	[], // 7 sidearm ammo pri
	[], // 8 sidearm ammo sec
	["HandGrenade_West","HandGrenade_East","HandGrenade","BAF_L109A1_HE","ACE_Flashbang","ACE_M84","ACE_TORCH_C"], // 9 grenades pri
	[], // 10 grenades sec
	["SmokeShell","SmokeShellGreen","SmokeShellRed","SmokeShellYellow","SmokeShellPurple","SmokeShellBlue","SmokeShellOrange","ACE_M34","ACE_RDG2","ACE_RDGM"], // 11 smoke pri
	[], // 12 smoke sec
	[], // 13 bandages pri
	[], // 14 bandages sec
	[], // 15 meds1 pri
	[], // 16 meds1 sec
	[], // 17 meds2 pri
	[]  // 18 meds2 sec
];

_nc = [ // How many of each item I need to grab
	0, // need weapon 1
	0, // need weapon 2
	0, // need sidearm
	0, // mags 1 pri
	0, // mags 1 sec
	0, // mags 2 pri
	0, // mags 2 sec
	0, // mags 3 pri
	0, // mags 3 sec
	0, // nade pri
	0, // nade sec
	0, // smoke pri
	0, // smoke sec
	0, // band pri
	0, // band sec
	0, // med1 pri
	0, // med1 sec
	0, // med2 pri
	0  // med2 sec
];

_nw = false; // need some weapon
_na = false; // need some ammo

_needmax = [	// The level of supplies the unit will try to maintain
	0, // not used
	0, // not used
	0, // not used
	3, // mags
	3, // gl
	1, // rpg
	1, // spotting
	2, // pistol pri
	2, // pistol sec
	1, // nades pri
	0, // nades sec - not defined
	1, // smoke pri
	0, // smoke sec - not defined
	0, // band pri - not defined
	1, // band sec
	0, // morp pri - not defined
	1, // morp sec
	0, // epi pri - not defined
	1  // epi sec
];

_locksecondary = false;
_w = "";
_t = "";

if (_full) then {
  _freeslots = [_unit] call FUNC(invSlotsEmpty);
  // select:
  //	0 WeaponSlotPrimary
  //	1 WeaponSlotHandGun
  //	2 WeaponSlotSecondary
  //	3 WeaponSlotHandGunItem
  //	4 WeaponSlotItem
  //	5 WeaponSlotBinocular
  //	6 WeaponHardMounted
  //	7 WeaponSlotInventory
  // probably not going to stricty check if some mags fit, just if there's any empty slot
  //TRACE_2("EMPTY SLOTS",_unit,_freeslots);
};

//-- Inventory check: weapon types, compatible mags - fill in the _nt array

_w = primaryWeapon _unit;
if (_w != "") then {
	_t = [_w] call FUNC(getType);
	if (_t in ["RIFLE","SNIPER","MG","AR"]) then {
		_nt set [0,_w];
		_nt set [3,([_w] call FUNC(getCompatMags)) select 0];
		_nt set [4,([_w] call FUNC(getCompatMags)) select 1];
		if (_t != "RIFLE") then { //specialist primary weapon
			_locksecondary = true; // don't take a launcher
			_needmax set [3,5]; // take 2 more mags
		};
	};
};

if ([_unit] call FUNC(isMedic) || !isNull(unitBackpack _unit)) then { // unit is a medic or has ruck
	_locksecondary = true; // don't take a launcher
	_needmax set [3,5]; // take 2 more mags
};
//TRACE_2("LOCK SECONDARY",_unit,_locksecondary);

_w = secondaryWeapon _unit;
if (_w != "") then {
	_t = [_w] call FUNC(getType);
	if (_t == "LAUNCHER") then	{
		_nt set [1,_w];
		_nt set [5,([_w] call FUNC(getCompatMags)) select 0];
		_nt set [6,([_w] call FUNC(getCompatMags)) select 1];
	};
};

// if a handgun is found
_w = [_unit] call CBA_fnc_getPistol;
if (_w != "") then {
	_nt set [2,_w];
	_nt set [7,([_w] call FUNC(getCompatMags)) select 0];
	_nt set [8,([_w] call FUNC(getCompatMags)) select 1];
};

//-- Determine what this unit needs - based on needmax, fill the _nc array

if (_nt select 0 == "") then { // don't have a primary
	_nc set [0, 1];
	_nw = true;
} else { // have primary, count mags
	_p = [_unit,_nt select 3] call FUNC(countMags);
	_s = [_unit,_nt select 4] call FUNC(countMags);
	if (_full) then {
		if (_p < _needmax select 3 && _freeslots select 4 > 0) then {_nc set [3,(_needmax select 3) - _p]};
		if (_s < _needmax select 4 && _freeslots select 3 > 0) then {_nc set [4,(_needmax select 4) - _s]};
	};
	if (_p == 0 && _s == 0) then {_nc set [0, 1]; _nw = true;}; // no mags ? look for another weapon
};

if (_nt select 1 == "") then { // don't have a launcher
	if (_full) then {
		if (_freeslots select 2 > 0 && !_locksecondary) then {_nc set [1, 1]; _nw = true;}; //take one if slot not full or locked by primary weapon conditions
	};
} else { // it's a launcher
	_p = [_unit,_nt select 5] call FUNC(countMags);
	_s = [_unit,_nt select 6] call FUNC(countMags);
	if (_p < _needmax select 5) then {_nc set [5,(_needmax select 5) - _p]}; // without free slot check
	if (_full) then {
		if (_s < _needmax select 6 && _freeslots select 3 > 0) then {_nc set [6,(_needmax select 6) - _s]};
	};
	if (_p == 0 && !_locksecondary) then {_nc set [1, 1]; _nw = true;}; // no primary rounds, look for another one
};

if (_full) then {

  if (GVAR(sidearm) == 1) then { // care about sidearms ? (check config)
  	if (_nt select 2 == "" && _freeslots select 3 > 0) then { // don't have a sidearm (and have free secondary slots)
  		_nc set [2, 1];
  		_nw = true;
  	} else {
  		_p = [_unit,_nt select 7] call FUNC(countMags);
  		_s = [_unit,_nt select 8] call FUNC(countMags);
  		if (_p < _needmax select 7 && _freeslots select 4 > 0) then {_nc set [7,(_needmax select 7) - _p]};
  		if (_s < _needmax select 8 && _freeslots select 3 > 0) then {_nc set [8,(_needmax select 8) - _s]};
  		if (_p == 0 && _s == 0  && _freeslots select 3 > 0) then {_nc set [2, 1]; _nw = true;}; // have one but empty, look for another
  	};
  };

	{// Check for Handgrenades and Smokeshells
		_p = [_unit,_nt select _x] call FUNC(countMags);
		if (_p < _needmax select _x && _freeslots select 4 > 0) then {_nc set [_x,(_needmax select _x) - _p]};
	} forEach [9,11];

};

// ACE mod extras
if (_acew) then {
	_nt set [14, (_nt select 14) + ["ACE_Bandage"]];
	_nt set [16, (_nt select 16) + ["ACE_Morphine"]];
	_nt set [18, (_nt select 18) + ["ACE_Epinephrine"]];

	// Check for bandages
	_s = [_unit,_nt select 14] call FUNC(countMags);
	if (_s < _needmax select 14) then {_nc set [14,(_needmax select 14) - _s]};

	// Medics look for murphy & epi
	if ([_unit] call FUNC(isMedic)) then {
		{// Check for morphine and epi
			_s = [_unit,_nt select _x] call FUNC(countMags);
			if (_s < _needmax select _x) then {_nc set [_x,(_needmax select _x) - _s]};
		} forEach [16,18];
	};
};

// set the need ammo boolean
for "_i" from 3 to ((count _nc) - 1) do {
	if (_nc select _i > 0) then {_na = true};
};

//TRACE_5("INVCHECK",_unit,_nw,_na,_nt,_nc);
[_nw,_na,_nt,_nc]
